stages:
  - build
  - test
  - deliver

variables:
  PYTHONPATH: "./app:$PYTHONPATH"

build:
  stage: build
  image: python:3.9-alpine
  before_script:
    - apk add --no-cache build-base
    - pip install -r requirements.txt
    - pip install flake8 pylint

  script:
    - flake8 src/ tests/
    - pylint src/ tests/
    
  
unittest:
  stage: test
  image: python:3.9-alpine
  script:
    - apk add --no-cache build-base
    - pip install -r requirements.txt
    - python -m unittest discover -s tests -p 'test_*.py' -v

deliver:
  stage: deliver
  image: docker:latest
  services:
    - name: docker:dind
   
  script:
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
    - docker build -t $CI_REGISTRY_IMAGE:latest -t $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA $CI_PROJECT_DIR
    - docker push $CI_REGISTRY_IMAGE:latest
    - docker push $CI_REGISTRY_IMAGE:$CI_COMMIT_SHA
  environment:
    name: production
  only:
    - main
